"use strict";import{html as m}from"@spectrum-web-components/base";import{classMap as p,ifDefined as c,styleMap as g}from"@spectrum-web-components/base/src/directives.js";import{MutationController as v}from"@lit-labs/observers/mutation-controller.js";import{SliderHandle as f}from"./SliderHandle.js";export class HandleController{constructor(e){this.handles=new Map;this.model=[];this.handleOrder=[];this.handleOrientation=()=>{this.updateBoundingRect()};this.extractModelFromLightDom=()=>{let e=[...this.host.querySelectorAll('[slot="handle"]')];e.length===0&&(e=[this.host]),!e.some(t=>this.waitForUpgrade(t))&&(this.handles=new Map,this.handleOrder=[],e.forEach((t,n)=>{var a;(a=t.handleName)!=null&&a.length||(t.name=`handle${n+1}`),this.handles.set(t.handleName,t),this.handleOrder.push(t.handleName),t.handleController=this}),this.requestUpdate())};this.onInputChange=e=>{const t=e.target;t.model.handle.value=t.valueAsNumber,this.requestUpdate(),this.dispatchChangeEvent(t,t.model.handle)};this.onInputFocus=e=>{const t=e.target;let n;try{n=t.matches(":focus-visible")||this.host.matches(".focus-visible")}catch(a){n=this.host.matches(".focus-visible")}t.model.handle.highlight=n,this.requestUpdate()};this.onInputBlur=e=>{const t=e.target;t.model.handle.highlight=!1,this.requestUpdate()};this.onInputKeydown=e=>{var n;if(e.key=="Escape"){const a=e.target;((n=a.model.handle)==null?void 0:n.defaultValue)!==void 0&&a.model.handle.value!==a.model.handle.defaultValue&&(a.model.handle.value=a.model.handle.defaultValue,a.model.handle.dispatchInputEvent(),this.dispatchChangeEvent(a,a.model.handle),this.requestUpdate(),e.preventDefault(),e.stopPropagation());return}const t=e.target;t.model.handle.highlight=!0,this.requestUpdate()};this.host=e,new v(this.host,{config:{subtree:!0,childList:!0},callback:()=>{this.extractModelFromLightDom()}}),this.extractModelFromLightDom()}get values(){const e={};for(const t of this.handles.values())e[t.handleName]=t.value;return e}get size(){return this.handles.size}inputForHandle(e){if(this.handles.has(e.handleName)){const{input:t}=this.getHandleElements(e)||{};return t}throw new Error(`No input for handle "${e.name}"`)}requestUpdate(){this.host.hasUpdated&&this.host.requestUpdate()}setValueFromHandle(e){const t=this.getHandleElements(e);if(!t)return;const{input:n}=t;n.valueAsNumber===e.value?e.dragging&&e.dispatchInputEvent():(n.valueAsNumber=e.value,this.requestUpdate()),e.value=n.valueAsNumber}handleHasChanged(e){e!==this.host&&this.requestUpdate()}formattedValueForHandle(e){var i;const{handle:t}=e,n=(i=t.numberFormat)!=null?i:this.host.numberFormat,a=t._forcedUnit===""?this.host._forcedUnit:t._forcedUnit;return t.getAriaHandleText(e.value,n)+a}get formattedValues(){const e=new Map;for(const t of this.model)e.set(t.name,this.formattedValueForHandle(t));return e}get focusElement(){const{input:e}=this.getActiveHandleElements();return!e||this.host.editable&&!e.model.handle.dragging?this.host.numberField:e}hostConnected(){"orientation"in screen?screen.orientation.addEventListener("change",this.handleOrientation):window.addEventListener("orientationchange",this.handleOrientation)}hostDisconnected(){"orientation"in screen?screen.orientation.removeEventListener("change",this.handleOrientation):window.removeEventListener("orientationchange",this.handleOrientation)}hostUpdate(){this.updateModel()}waitForUpgrade(e){return e instanceof f?!1:(e.addEventListener("sp-slider-handle-ready",()=>this.extractModelFromLightDom(),{once:!0,passive:!0}),!0)}get activeHandle(){return this.handleOrder[this.handleOrder.length-1]}get activeHandleInputId(){const e=this.activeHandle;return`input-${this.model.findIndex(n=>n.name===e)}`}activateHandle(e){const t=this.handleOrder.findIndex(n=>n===e);t>=0&&this.handleOrder.splice(t,1),this.handleOrder.push(e)}get activeHandleModel(){const e=this.activeHandle;return this.model.find(t=>t.name===e)}getActiveHandleElements(){const e=this.activeHandle,t=this.handles.get(e),n=this.getHandleElements(t);return{model:t,...n}}getHandleElements(e){if(!this.handleRefMap){this.handleRefMap=new WeakMap;const n=this.host.shadowRoot.querySelectorAll(".handle > input");for(const a of n){const i=a,l=i.parentElement,r=this.handles.get(l.getAttribute("name"));r&&this.handleRefMap.set(r,{input:i,handle:l})}}return this.handleRefMap.get(e)}clearHandleComponentCache(){delete this.handleRefMap}get boundingClientRect(){return this._boundingClientRect||(this._boundingClientRect=this.host.track.getBoundingClientRect()),this._boundingClientRect}updateBoundingRect(){delete this._boundingClientRect}extractDataFromEvent(e){if(!this._activePointerEventData){let t=e.target.querySelector(":scope > .input");const n=!t,a=t?t.model:this.model.find(i=>i.name===this.activeHandle);!t&&a&&(t=a.handle.focusElement),this._activePointerEventData={input:t,model:a,resolvedInput:n}}return this._activePointerEventData}handleDoubleClick(e){var n;const t=e.target.querySelector(".input");((n=t.model)==null?void 0:n.handle.defaultValue)!==void 0&&(t.model.handle.value=t.model.handle.defaultValue,this.dispatchChangeEvent(t,t.model.handle),t.model.handle.dispatchInputEvent(),this.requestUpdate())}handlePointerdown(e){const{resolvedInput:t,model:n}=this.extractDataFromEvent(e);if(!n||this.host.disabled||e.button!==0){e.preventDefault();return}this.host.track.setPointerCapture(e.pointerId),this.updateBoundingRect(),e.pointerType==="mouse"&&this.host.labelEl.click(),this.draggingHandle=n.handle,n.handle.dragging=!0,this.activateHandle(n.name),t&&this.handlePointermove(e),this.requestUpdate()}handlePointerup(e){const{input:t,model:n}=this.extractDataFromEvent(e);delete this._activePointerEventData,n&&(e.pointerType==="mouse"&&this.host.labelEl.click(),this.cancelDrag(n),this.requestUpdate(),this.host.track.releasePointerCapture(e.pointerId),this.dispatchChangeEvent(t,n.handle))}handlePointermove(e){const{input:t,model:n}=this.extractDataFromEvent(e);n&&this.draggingHandle&&(t.value=this.calculateHandlePosition(e,n).toString(),n.handle.value=parseFloat(t.value),this.host.indeterminate=!1,this.requestUpdate())}cancelDrag(e){e=e||this.model.find(t=>t.name===this.activeHandle),e&&(e.handle.highlight=!1,delete this.draggingHandle,e.handle.dragging=!1)}dispatchChangeEvent(e,t){e.valueAsNumber=t.value;const n=new Event("change",{bubbles:!0,composed:!0});t.dispatchEvent(n)}calculateHandlePosition(e,t){const n=this.boundingClientRect,a=n.left,i=e.clientX,l=n.width,s=(this.host.isLTR?i-a:l-(i-a))/l;return t.normalization.fromNormalized(s,t.range.min,t.range.max)}renderHandle(e,t,n,a){var s;const i={handle:!0,dragging:((s=this.draggingHandle)==null?void 0:s.handleName)===e.name,"handle-highlight":e.highlight},l={[this.host.isLTR?"left":"right"]:`${e.normalizedValue*100}%`,"z-index":n.toString(),...a&&{"background-color":`var(--spectrum-slider-handle-background-color-${t}, var(--spectrum-slider-handle-background-color))`,"border-color":`var(--spectrum-slider-handle-border-color-${t}, var(--spectrum-slider-handle-border-color))`}},r=a?`label input-${t}`:"label";return m`
            <div
                class=${p(i)}
                name=${e.name}
                style=${g(l)}
                role="presentation"
            >
                <input
                    type="range"
                    class="input"
                    id="input-${t}"
                    min=${e.clamp.min}
                    max=${e.clamp.max}
                    step=${e.step}
                    value=${e.value}
                    aria-disabled=${c(this.host.disabled?"true":void 0)}
                    tabindex=${c(this.host.editable?-1:void 0)}
                    aria-label=${c(e.ariaLabel)}
                    aria-labelledby=${r}
                    aria-valuetext=${this.formattedValueForHandle(e)}
                    aria-describedby="slider-description"
                    @change=${this.onInputChange}
                    @focus=${this.onInputFocus}
                    @blur=${this.onInputBlur}
                    @keydown=${this.onInputKeydown}
                    .model=${e}
                />
                <span id="slider-description">
                    Press escape or double click to reset the slider to its
                    default value.
                </span>
            </div>
        `}render(){return this.clearHandleComponentCache(),this.model.map((e,t)=>{const n=this.handleOrder.indexOf(e.name)+2;return this.renderHandle(e,t,n,this.model.length>1)})}trackSegments(){const e=this.model.map(t=>t.normalizedValue);return e.sort((t,n)=>t-n),e.unshift(0),e.map((t,n,a)=>{var i;return[t,(i=a[n+1])!=null?i:1]})}updateModel(){const e=[...this.handles.values()],t=a=>{const i=e[a],l=e[a-1],r=e[a+1],s=typeof i.min=="number"?i.min:this.host.min,u=typeof i.max=="number"?i.max:this.host.max,d={range:{min:s,max:u},clamp:{min:s,max:u}};if(i.min==="previous"&&l){for(let o=a-1;o>=0;o--){const h=e[o];if(typeof h.min=="number"){d.range.min=h.min;break}}d.clamp.min=Math.max(l.value,d.range.min)}if(i.max==="next"&&r){for(let o=a+1;o<e.length;o++){const h=e[o];if(typeof h.max=="number"){d.range.max=h.max;break}}d.clamp.max=Math.min(r.value,d.range.max)}return d},n=e.map((a,i)=>{var o;const l=t(i),{toNormalized:r}=a.normalization,s=Math.max(Math.min(a.value,l.clamp.max),l.clamp.min),u=r(s,l.range.min,l.range.max);return{name:a.handleName,value:s,normalizedValue:u,highlight:a.highlight,step:(o=a.step)!=null?o:this.host.step,normalization:a.normalization,handle:a,ariaLabel:a!==this.host&&(a==null?void 0:a.label.length)>0?a.label:void 0,...l}});this.model=n}async handleUpdatesComplete(){const e=[...this.handles.values()].filter(t=>t!==this.host).map(t=>t.updateComplete);await Promise.all(e)}}
//# sourceMappingURL=HandleController.js.map
